(in-package :c2ffi)

(export '(generate-xml))

(defvar *gccxml-command* "gccxml")

(defun generate-xml (h-file xml-file &optional options)
  (format *terminal-io* "~&~%Running ~A~%Options: ~A~%Input: ~S~%Output: ~S~%"
	  *gccxml-command* options
	  (namestring (truename h-file))
	  (namestring xml-file))

  #+:openmcl
  (ccl:run-program *gccxml-command*
		   (append options
			   (list (namestring (truename h-file))
				 (str+ "-fxml=" (namestring xml-file))))
		   :output *terminal-io*
		   :error *error-output*)
  #-:openmcl
  (error "Generate-XML is currently only implemented for OpenMCL.  Please run gccxml from the command line on other platforms."))
